import uno, unohelper
from com.sun.star.util import XModifyListener
from com.sun.star.task import XJob


# CellFlags
VALUE = 1
STRING = 4
FORMULA = 16


class MoreSheetsListener(XModifyListener, unohelper.Base):
    """listens for change in attached cell, Cell should never
    have a zero (0) value, and Workbook MUST start with 2 or more sheets"""

    def __init__(self,):
        self.doc = None

    def setSheets(self, doc):
        self.oSheets = doc.getSheets()

    def modified(self, oEv):
        print ("modified and now " + oEv.Source.Value)

    def disposing(self, oEv):
        pass


#-----------------------------------------------------------------------------

class EraCase(XJob, unohelper.Base):
    def __init__(self, ctx):
        #print("initiated.")
        self.ctx = ctx
    def execute(self, args):
        if not args: return
        correctEvent = False
        for arg in args:
            if arg.Name == "Environment":
                value = arg.Value
                for v in value:
                    if v.Name == "EnvType" and v.Value == "DOCUMENTEVENT":
                        correctEvent = True
                    elif v.Name == "Model":
                        doc = v.Value
        if correctEvent:
            if doc.supportsService("com.sun.star.sheet.SpreadsheetDocument"):
                try:
                    if doc.DocumentProperties.UserDefinedProperties.TWOHOT:
                        monitor = MoreSheetsListener()
                        monitor.setSheets(doc)
                        oSheets = doc.getSheets()
                        ocell = oSheets.getByIndex(0).getCellRangeByName('A1')
                        ocell.addModifyListener(monitor)
                        print("Listening")
                except:
                    print("Ignoring")


g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation(
    EraCase,"twohot.task.job",
    ("com.sun.star.task.Job",),
)
